/* Immidiate called*/

(function () {
  'use strict';

  var verbose = false;
  var timers = [];
  var int_SetTimeout = window.setTimeout;
  var int_clearTimeout = window.clearTimeout;
  var WebOSTimers = [];
    
  window.clearLayoutTimeouts = function (scp) {
    if (WebOSTimers[scp] !== undefined) {
      WebOSTimers[scp].forEach(function (element) {
        clearTimeout(element);
        if (verbose) {
          console.debug("clearLayoutTimeouts", element);
        }
      });
      WebOSTimers[scp] = [];
    }
  };

  window.setTimeout = function (func, timeout, layoutID, scp) {
    var t = int_SetTimeout(function () {
      //console.log("Internal call");
      var index = timers.indexOf(t);
      if (index > -1) {
        timers.splice(index, 1);
      }
      func();
    }, timeout);
    if (layoutID) {
      if (verbose) {
        console.debug("Add timeout " + t + " for layout " + layoutID);
      }
    } else {
      if (verbose) {
        console.debug("Add timeout " + t);
      }
    }
    timers.push(t);
    if (scp !== null) {
      if (WebOSTimers[scp] === undefined || WebOSTimers[scp] === null) {
        WebOSTimers[scp] = [];
      }
      WebOSTimers[scp].push(t);
    }
    //console.log("Timeout "+t+" added ("+(timeout|0)+" ms) with tag " + tag + "!");
    return t;
  };

  window.clearTimeout = function (timeoutID) {
    if (verbose) {
      console.debug("Remove timeout " + timeoutID);
    }
    var index = timers.indexOf(timeoutID);
    if (index > -1) {
      timers.splice(index, 1);
    }
    int_clearTimeout(timeoutID);
  };

  window.countTimeouts = function () {
    return timers.length;
  };

  window.showTimers = function () {
    console.debug("WebOSTimers", WebOSTimers);
  };
}());