//jshint ignore:start

var dynamicLoader = new function dynamicLoader(){
  var loadedModules = [];
  var nextLoadModules = [];
  var that = this;
  
  this.onComplete = null;

  this.load = function load(url){
    if (loadedModules.indexOf(url)>-1){
      return this;
    }
    
    nextLoadModules.push(url);
    if (nextLoadModules.length>1){return this;};
    
    var internalLoad = function internalLoad(intUrl){
      
      var downloadNext = function downloadNext(){
        if (nextLoadModules.length>0){
          internalLoad(nextLoadModules.shift());
        }else{
          //console.timeStamp("Finish all downloads!");
          if ((that.onComplete !== null) && (typeof that.onComplete === "function") ){
            that.onComplete();
          }
        }
      };
      
      if (loadedModules.indexOf(intUrl)>-1){
          //console.log("Trying to load "+intUrl+" again!");
          downloadNext();
          return;
      }
      var tag = document.createElement( 'script' );
      tag.type = 'text/javascript';
      tag.src = intUrl;
      tag.onreadystatechange = function onreadystatechange(){
        //console.timeStamp(this.src+" loaded!");
        downloadNext();
      };
      tag.onload = function onload(){
        //console.timeStamp(this.src+" loaded!");
        downloadNext();
      };
      document.getElementsByTagName("head")[0].appendChild( tag );
      loadedModules.push(intUrl);
    };
    setTimeout(function(){
      //console.timeStamp("Start downloading!");
      internalLoad(nextLoadModules.shift());
    },0);
    
    return that;
  };
};
