/**
 * Copyright (C) Intelligent Media LTD - All Rights Reserved
 *
 * This source code is protected under international copyright law.  All rights
 * reserved and protected by the copyright holders.
 * This file is confidential and only available to authorized individuals with the
 * permission of the copyright holders.  If you encounter this file and do not have
 * permission, please contact the copyright holders and delete this file.
 *
 * Author : Apostolos Katranitsas <ak@intelligentmedia.gr>
 * Contributors :
 *   -  Elias Papadakis <ep@intelligentmedia.gr>
 */
/* global utils */
(function () {
  "use strict";

  window.LayoutManager.transout = function (element, container, transOutType, transOutDuration, transOutDirection, callback) {
    if (transOutType === "fadeIn") {
      utils.hide(element);
      utils.fadeIn(element, parseInt(transOutDuration), function () {
        callback();
      });
    } else if (transOutType === "fadeOut") {
      utils.show(element);
      utils.fadeOut(element, parseInt(transOutDuration), function () {
        callback();
      });
    } else if (transOutType === "fly") {
      element.style.position = "absolute";
      var position = {
        top: parseInt(element.style.top),
        left: parseInt(element.style.left)
      };
      var top = position.top;
      var left = position.left;
      if (transOutDirection.indexOf("S") >= 0) {
        if (DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_LANDSCAPE || DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_REVERSE_LANDSCAPE) {
          top = (utils.getElementHeight(container.parentElement) - container.offsetTop);

        } else {
          if (viewContainer.offsetWidth > viewContainer.offsetHeight) {
            top = ((screen.height / (screen.width / utils.getElementWidth(container.parentElement)) - utils.getElementHeight(container.parentElement)) / 2 + utils.getElementHeight(container.parentElement));
          } else {
            top = (utils.getElementHeight(container.parentElement) - container.offsetTop); //if the layout has the same orientation as the monitor
          }

        }
      }
      if (transOutDirection.indexOf("N") >= 0) {
        if (DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_LANDSCAPE || DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_REVERSE_LANDSCAPE) {
          top = "-" + (utils.getElementHeight(element) + container.offsetTop);
        } else {
          if (viewContainer.offsetWidth > viewContainer.offsetHeight) {
            top = "-" + ((screen.height / (screen.width / utils.getElementWidth(container.parentElement)) - utils.getElementHeight(container.parentElement)) / 2 + utils.getElementHeight(element) + container.offsetTop);
          } else {
            top = "-" + (utils.getElementHeight(element) + container.offsetTop); //if the layout has the same orientation as the monitor
          }

        }
      }
      if (transOutDirection.indexOf("W") >= 0) {
        if (DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_LANDSCAPE || DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_REVERSE_LANDSCAPE) {
          if (viewContainer.offsetWidth < viewContainer.offsetHeight) {

            left = "-" + ((screen.width / (screen.height / utils.getElementHeight(container.parentElement)) - utils.getElementWidth(container.parentElement)) / 2 + utils.getElementWidth(element) + container.offsetLeft);
          } else {
            left = "-" + (utils.getElementWidth(element) + container.offsetLeft); //if the layout has the same orientation as the monitor
          }
        } else {
          left = "-" + (utils.getElementWidth(element) + container.offsetLeft);// (utils.getElementWidth(container.parentElement) - container.offsetLeft);
        }
      }
      if (transOutDirection.indexOf("E") >= 0) {
        if (DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_LANDSCAPE || DeviceManager.Device.getOrientation() == DeviceManager.Device.SCREENORIENTATION_REVERSE_LANDSCAPE) {
          if (viewContainer.offsetWidth < viewContainer.offsetHeight) {
            left = ((screen.width / (screen.height / utils.getElementHeight(container.parentElement)) - utils.getElementWidth(container.parentElement)) / 2 + utils.getElementWidth(container.parentElement) - container.offsetLeft);
          } else {
            left = (utils.getElementWidth(container.parentElement) - container.offsetLeft);//if the layout has the same orientation as the monitor
          }
        } else {
          left = (utils.getElementWidth(container.parentElement) - container.offsetLeft);
        }


      }
      //jQueryWebOs(element).animate({left: left, top: top}, parseInt(transOutDuration), 'swing', function() { callback(); });        
      utils.animate(element, {left: left, top: top}, parseInt(transOutDuration), function () {
        callback();
      });

    }
  };
}());