/* global process */

var express = require('express');
var http = require('http');

var app = express();
app.disable('x-powered-by');
app.use(express.json());

var server = http.createServer(app);
var io = require('socket.io')(server);

var v_client = null;

io.addListener('connection', function(client){
  v_client = client;
//  client.emit('log', JSON.stringify({data:'ws hello'}));
});


app.get('/status', function(req, res) {
  res.send({status:'OK'});
});
/*
    env: process.env, 
    versions: process.versions
*/
app.post('/info', function(req, res) {
  if (v_client){
    v_client.emit('info', function(data){
      res.send(data);
  //        {
  //        "hardwareKey": "hwKey",
  //        "displayName": "displayName",
  //        "timeZone": "Europe/Athens",
  //        "latitude": null,
  //        "longitude": null
  //      }
    });
  }else{
    res.status(503).send();
  }
});

app.post('/trigger', function(req, res) {
  if (v_client){
    v_client.emit('trigger', req.body, function(data){
      res.send({status:'OK', data:data});    
    });
  }else{
    res.status(503).send();
  }
});

app.post('/duration/expire', function(req, res) {
  if (v_client){
    v_client.emit('/duration/expire', req.body, function(data){
      res.send({status:'OK', data:data});    
    });
  }else{
    res.status(503).send();
  }
});

app.post('/duration/extend', function(req, res) {
  if (v_client){
    v_client.emit('/duration/extend', req.body, function(data){
      res.send({status:'OK', data:data});    
    });
  }else{
    res.status(503).send();
  }
});

app.post('/duration/set', function(req, res) {
  if (v_client){
    v_client.emit('/duration/set', req.body, function(data){
      res.send({status:'OK', data:data});    
    });
  }else{
    res.status(503).send();
  }
});

app.use(function(req, res, next) {
  res.connection.destroy();
});



module.exports = {
  server : server,
  app : app,
  io : io
};
//server.listen(9696);
